## pd-faust-0.18.tar.gz

=== Makefile ===

# This is a GNU makefile. Please also check Makefile.config for customizable
# setup information and Makefile.common for the actual compilation rules.

# Normally you just run 'make' and then 'make install' to build and install
# the package. The usual standard targets to clean (clean, distclean,
# realclean) and roll a distribution tarball (dist, distcheck) are supported
# as well. 'make install' also honors DESTDIR so that staged installs can be
# done conveniently by package maintainers.

# Installation goes to extra/faust in your Pd library directory by default.
# The Makefile tries to detect the location of your Pd installation. You can
# change this by setting any of the prefix, libdir, pdlibdir and pdextradir
# variables on the command line, see below for the defaults.

# If you'd like to experiment with Faust bitcode modules which can be loaded
# natively by the Pure interpreter, you also need to run 'make bitcode' before
# 'make install'. Please check pdfaust.pure for details.

include Makefile.config

# Package name and version:
dist = pd-faust-$(version)
version = 0.18

DISTFILES = COPYING COPYING.LESSER Makefile Makefile.config.in Makefile.config \
Makefile.common README TODO config.guess *.pure etc/*.el etc/*.pd \
debian/* examples/*.pd examples/midi/*.mid examples/osc/*.osc \
examples/dsp/README* examples/dsp/Makefile \
examples/dsp/*.dsp examples/dsp/*.lib examples/dsp/*.h \
lib/Makefile lib/*.c lib/*.dsp lib/*.pure pd/*.h
SEDFILES = README

subdirs = lib examples/dsp

all:
	for x in $(subdirs); do $(MAKE) -C $$x PUREC_FLAGS="$(PUREC_FLAGS)" all; done

bitcode:
	for x in $(subdirs); do $(MAKE) -C $$x PUREC_FLAGS="$(PUREC_FLAGS)" bitcode; done

clean:
	for x in $(subdirs); do $(MAKE) -C $$x clean; done

distclean:
	for x in $(subdirs); do $(MAKE) -C $$x distclean; done

realclean:
	for x in $(subdirs); do $(MAKE) -C $$x realclean; done

install:
	test -d "$(DESTDIR)$(pdextradir)" || mkdir -p "$(DESTDIR)$(pdextradir)"
	cp examples/faust-remote.pd "$(DESTDIR)$(pdlibdir)/extra"
	cp COPYING COPYING.LESSER README TODO examples/*.pd etc/*.el lib/pdfaust*$(PDDLL) "$(DESTDIR)$(pdextradir)"
	cp -R examples/dsp examples/midi examples/osc "$(DESTDIR)$(pdextradir)"
	test -d "$(DESTDIR)$(pdextradir)/lib" || mkdir -p "$(DESTDIR)$(pdextradir)/lib"
	cp lib/util.* lib/xfade.* "$(DESTDIR)$(pdextradir)/lib"
	test -d "$(DESTDIR)$(pdextradir)/src" || mkdir -p "$(DESTDIR)$(pdextradir)/src"
	cp *.pure "$(DESTDIR)$(pdextradir)/src"

uninstall:
	rm -rf "$(DESTDIR)$(pdextradir)" "$(DESTDIR)$(pdlibdir)/extra/faust-remote.pd"

Makefile.config: Makefile.config.in Makefile
	sed -e "s?@version@?$(version)?g" < $< > $@

date = $(shell date "+%B %-d, %Y")
datesubst = sed -e "s?@version@?$(version)?g" -e "s?|today|?$(date)?g" < $(1) > $(2)

dist:
	rm -rf $(dist)
	for x in $(dist) $(addprefix $(dist)/, debian etc lib pd examples $(addprefix examples/, dsp midi osc)); do mkdir $$x; done
	for x in $(DISTFILES); do ln -sf "$$PWD"/$$x $(dist)/$$x; done
	for x in $(SEDFILES); do rm -f $(dist)/$$x; $(call datesubst,"$$PWD"/$$x,$(dist)/$$x); done
	rm -f $(dist).tar.gz
	tar cfzh $(dist).tar.gz $(dist)
	rm -rf $(dist)

distcheck: dist
	tar xfz $(dist).tar.gz
	cd $(dist) && make && make install DESTDIR=./BUILD
	rm -rf $(dist)

debsrc = $(shell echo $(dist) | sed -e 's/-$(version)/_$(version)/').orig.tar.gz

deb: $(debsrc) dist
	tar xfz $(dist).tar.gz
	cd $(dist) && debuild $(DEBUILD_FLAGS)
	rm -rf $(dist)

$(debsrc):
	wget -nv https://github.com/agraef/pure-lang/releases/download/$(dist)/$(dist).tar.gz -O $@

# Special rules to build the Pd-L2Ork and Purr-Data versions.

l2ork-debsrc = $(shell echo $(dist) | sed -e 's/pd-faust/pdl2ork-faust/' -e 's/-$(version)/_$(version)/').orig.tar.gz

l2ork-deb: $(l2ork-debsrc) dist
	tar xfz $(dist).tar.gz
	cd $(dist)/debian && mkdir l2ork && (sed -e 's/pd-faust/pdl2ork-faust/g' changelog > l2ork/changelog) && (sed -e 's/pd-faust/pdl2ork-faust/g' -e 's/pd-pure/pdl2ork-pure/g' -e 's/puredata/pd-l2ork/g' control > l2ork/control) && (sed -e 's/--/-- PD=pd-l2ork/g' rules > l2ork/rules) && chmod a+x l2ork/rules && mv -f l2ork/* . && rmdir l2ork
	cd $(dist) && debuild $(DEBUILD_FLAGS)
	rm -rf $(dist)

$(l2ork-debsrc):
	wget -nv https://github.com/agraef/pure-lang/releases/download/$(dist)/$(dist).tar.gz -O $@

purrdata-debsrc = $(shell echo $(dist) | sed -e 's/pd-faust/purrdata-faust/' -e 's/-$(version)/_$(version)/').orig.tar.gz

purrdata-deb: $(purrdata-debsrc) dist
	tar xfz $(dist).tar.gz
	cd $(dist)/debian && mkdir purrdata && (sed -e 's/pd-faust/purrdata-faust/g' changelog > purrdata/changelog) && (sed -e 's/pd-faust/purrdata-faust/g' -e 's/pd-pure/purrdata-pure/g' -e 's/puredata/purr-data/g' control > purrdata/control) && (sed -e 's/--/-- PD=purr-data/g' rules > purrdata/rules) && chmod a+x purrdata/rules && mv -f purrdata/* . && rmdir purrdata
	cd $(dist) && debuild $(DEBUILD_FLAGS)
	rm -rf $(dist)

$(purrdata-debsrc):
	wget -nv https://github.com/agraef/pure-lang/releases/download/$(dist)/$(dist).tar.gz -O $@

=== lib/Makefile ===

override srcdir = ..
include $(srcdir)/Makefile.common

override CPPFLAGS += -I$(pdincdir) -I../pd

solibs     := util$(DLL) pdstub$(DLL)
somodules  := $(dsp_source:.dsp=$(DLL))
bcmodules  := $(dsp_source:.dsp=.bc)

# The xfade dsp is needed by all effect plugins, preallocate some units.
$(somodules): CXXFLAGS += -DNVOICES=16

all: $(solibs) $(somodules) pdfaust$(PDDLL)
bitcode: $(bclibs) $(bcmodules) pdfaust2$(PDDLL)

# We need the location of some of the installed Pure library modules.
purelib = $(shell pkg-config pure --variable libdir)/pure

# pure-faust precompiled module.

ifneq "$(findstring -darwin,$(host))" ""
# OSX doesn't have -rpath, so we have to rely on that the proper load path is
# set when the libraries are linked. Also note that we need the -undefined
# dynamic_lookup linker flag here to link back into the Pd executable.
extralibs = -Wl,-undefined -Wl,dynamic_lookup $(addprefix $(purelib)/, orddict$(DLL) faust$(DLL) midifile$(DLL))
else ifneq "$(findstring -mingw,$(host))" ""
# Windows requires linking against the Pd library and the Pure plugin loader.
extralibs = -Wl,--enable-auto-import $(addprefix $(purelib)/, orddict$(DLL) faust$(DLL) midifile$(DLL)) "$(pdlibdir)/extra/pure/pure.dll" $(LIBPD) -lglob
else
# This requires a linker that handles the -rpath option. Otherwise you may
# have to add the Pure library directory to your system dll search path so
# that the linked library modules are found when the pdfaust module is loaded
# by Pd.
extralibs = -Wl,-rpath=$(purelib) $(addprefix $(purelib)/, orddict$(DLL) faust$(DLL) midifile$(DLL))
endif

pdfaust$(PDDLL): pdfaust.o pdloader.o util.o
	rm -f pdfaust$(PDDLL)
	$(CC) $(PIC) $(shared) $^ $(extralibs) -o pdfaust$(DLL) $(PURE_LIBS)
	test "$(DLL)" = "$(PDDLL)" || mv pdfaust$(DLL) pdfaust$(PDDLL)

pdfaust2$(PDDLL): pdfaust2.o pdloader2.o util.o
	rm -f pdfaust2$(PDDLL)
	$(CC) $(PIC) $(shared) $^ $(extralibs) -o pdfaust2$(DLL) $(PURE_LIBS)
	test "$(DLL)" = "$(PDDLL)" || mv pdfaust2$(DLL) pdfaust2$(PDDLL)

pdfaustsrc = $(addprefix ../, faust~.pure midiseq.pure oscseq.pure)
pdfaustdeps = $(wildcard ../*.pure)

pdfaust.o: $(pdfaustdeps)
	pure $(PIC) $(PUREC_FLAGS) -I.. -L.. -c $(pdfaustsrc) -o $@ --main __pdfaust_main__

pdfaust2.o: $(pdfaustdeps)
	pure $(PIC) $(PUREC_FLAGS) -I.. -L.. -c $(pdfaustsrc) -o $@ --main __pdfaust_main__ --enable faust2

pdloader.o: pdloader.c
	$(CC) $(ALL_CFLAGS) -DVERSION="\"$(version)\"" -c $< -o $@

pdloader2.o: pdloader.c
	$(CC) $(ALL_CFLAGS) -DVERSION="\"$(version)\"" -DFAUST2 -c $< -o $@

util.o: util.c
	$(CC) $(ALL_CFLAGS) -c $< -o $@

# Faust-specific stuff
svg: $(svg)
xml: $(xml)

clean:
	rm -f $(solibs) $(somodules) $(bclibs) $(bcmodules) *.o pdfaust$(PDDLL) pdfaust2$(PDDLL)

distclean: clean
	rm -Rf $(csource) $(cppsource) $(asmsource) $(svg) $(xml)

realclean: distclean

=== examples/dsp/Makefile ===

# GNU Makefile. Just run `make` to build the dsp modules in the native shared
# library format, or `make bitcode` for LLVM bitcode modules.

# This Makefile is self-contained, so you can just drop it into any directory
# with Faust dsp sources and run 'make' there to compile the modules to a
# format which is ready to be loaded with pd-faust.

CC = gcc
CXX = g++
#CC = clang
#CXX = clang++

# Default compilation flags. You may adjust these from the command line if
# necessary. The defaults here enable auto-vectorization and fast math on x86
# and similar cpus (this works with both gcc and clang). CPPFLAGS, LDFLAGS and
# LIBS are by default empty, but can also be set on the command line if you
# need them.
CFLAGS = -O3 -ffast-math -msse
CXXFLAGS = -O3 -ffast-math -msse

# Platform-specific setup. This uses the Pure pkg-config (pure.pc).
DLL = $(shell pkg-config pure --variable DLL)
PIC = $(shell pkg-config pure --variable PIC)
shared = $(shell pkg-config pure --variable shared)
PURE_INCLUDES = $(shell pkg-config pure --cflags)
PURE_LIBS = $(shell pkg-config pure --libs)

# LLVM setup. Make sure that we find the LLVM toolchain.
LLVM_CONFIG = $(word 1,$(shell which llvm-config) $(wildcard /opt/local/bin/llvm-config*) $(wildcard /usr/local/bin/llvm-config*) $(wildcard /usr/bin/llvm-config*))
LLVM_PATH = $(shell $(LLVM_CONFIG) --bindir)
PATH := $(LLVM_PATH):$(PATH)
# clang bitcode compilation.
LLVMCC = clang -emit-llvm
LLVMCXX = clang++ -emit-llvm

# Faust (we only require mainline Faust, but Faust2 will work as well).
FAUST = faust -double -cn $(<:.dsp=)
#FAUST = faust -double

# This is the collection of flags which actually gets passed in the C/C++
# recipes. Normally you shouldn't have to edit or override these.
ALL_CFLAGS = $(PIC) $(CFLAGS) $(CPPFLAGS) $(PURE_INCLUDES) -I.
ALL_CXXFLAGS = $(PIC) $(CXXFLAGS) $(CPPFLAGS) -I.
ALL_LDFLAGS = $(LDFLAGS) $(LIBS)

# Generic compilation rules.

# compile Faust source to C++ module (pure.cpp architecture)
%.cpp: %.dsp
	$(FAUST) -a pure.cpp $< -o $@

# compile Faust C++ module to shared lib
%$(DLL): %.cpp
	$(CXX) $(shared) $(ALL_CXXFLAGS) $< -o $@ $(ALL_LDFLAGS) $(PURE_LIBS)

# compile Faust source to C module (pure.c architecture)
%.c: %.dsp
	$(FAUST) -lang c -a pure.c $< -o $@

# compile Faust C module to LLVM bitcode (needs clang)
%.bc: %.c
	$(LLVMCC) $(ALL_CFLAGS) -c $< -o $@

# dsp sources
dspsource := $(sort $(wildcard *.dsp))

# target modules
cppsource := $(dspsource:%.dsp=%.cpp)
somodules := $(dspsource:.dsp=$(DLL))
bcmodules := $(dspsource:.dsp=.bc)
modules   := $(somodules) $(bcmodules)

# svg and xml/json targets
svg := $(dspsource:.dsp=-svg)
xml := $(dspsource:.dsp=.dsp.xml)
json := $(dspsource:.dsp=.dsp.json)

%-svg: %.dsp
	faust -svg -sd $< -o /dev/null >/dev/null

%.dsp.xml: %.dsp
	faust -xml $< -o /dev/null

%.dsp.json: %.dsp
	faust -json $< -o /dev/null

all: $(somodules)
bitcode: $(bcmodules)

# Faust-specific stuff
svg: $(svg)
xml: $(xml)
json: $(json)

clean:
	-rm -f $(modules)

distclean: clean
	rm -Rf $(cppsource) $(svg) $(xml) $(json)

realclean: distclean

=== debian/changelog ===
pd-faust (0.17-2) bionic; urgency=medium

  * Latest upstream fixes

 -- Albert Graef <aggraef@gmail.com>  Tue, 09 Oct 2018 05:54:22 +0200

pd-faust (0.17-1) bionic; urgency=medium

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Fri, 05 Oct 2018 21:53:41 +0200

pd-faust (0.16-1) bionic; urgency=medium

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Sun, 25 Feb 2018 12:26:28 +0100

pd-faust (0.15-1) artful; urgency=medium

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Tue, 16 Jan 2018 13:19:29 +0100

pd-faust (0.14-1) xenial; urgency=medium

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Sat, 07 Jan 2017 09:04:30 +0100

pd-faust (0.13-1) xenial; urgency=medium

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Sun, 01 Jan 2017 12:03:23 +0100

pd-faust (0.11-1) xenial; urgency=medium

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Fri, 14 Oct 2016 11:40:48 +0200

pd-faust (0.10-1) xenial; urgency=medium

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Sun, 05 Jun 2016 19:08:07 +0200

pd-faust (0.9-2) trusty; urgency=low

  * Latest upstream fixes

 -- Albert Graef <aggraef@gmail.com>  Tue, 28 Oct 2014 23:55:56 +0100

pd-faust (0.9-1) trusty; urgency=low

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Tue, 23 Sep 2014 07:11:11 +0200

pd-faust (0.8-1) trusty; urgency=low

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Wed, 17 Sep 2014 00:36:11 +0200

pd-faust (0.7-2) trusty; urgency=low

  * Pass the -mcpu=generic option to llc when batch-compiling Pure
    scripts, to prevent illegal instructions depending on the build host's
    cpu type.

 -- Albert Graef <aggraef@gmail.com>  Mon, 15 Sep 2014 09:52:09 +0200

pd-faust (0.7-1) trusty; urgency=low

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Sat, 13 Sep 2014 23:17:37 +0200

pd-faust (0.5-1) precise; urgency=low

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Thu, 19 Sep 2013 08:55:34 +0200

pd-faust (0.4-7) precise; urgency=low

  * Cosmetic changes (assume default samplerate of 44100 Hz)

 -- Albert Graef <Dr.Graef@t-online.de>  Tue, 29 Jan 2013 12:03:23 +0100

pd-faust (0.4-6) natty; urgency=low

  * Install extra Pd examples into lib/pd/extra/faust extra dir

 -- Albert Graef <Dr.Graef@t-online.de>  Mon, 28 May 2012 14:11:24 +0200

pd-faust (0.4-5) natty; urgency=low

  * Dependency fixes

 -- Albert Graef <Dr.Graef@t-online.de>  Mon, 28 May 2012 00:58:53 +0200

pd-faust (0.4-4) natty; urgency=low

  * Faust 0.9.47 or later needed for building

 -- Albert Graef <Dr.Graef@t-online.de>  Sat, 26 May 2012 22:13:57 +0200

pd-faust (0.4-3) natty; urgency=low

  * Add missing build dependency pkg-config

 -- Albert Graef <Dr.Graef@t-online.de>  Sat, 26 May 2012 03:43:28 +0200

pd-faust (0.4-2) natty; urgency=low

  * Add missing build dependency llvm
  * Remove duplicate documentation files

 -- Albert Graef <Dr.Graef@t-online.de>  Sat, 26 May 2012 00:52:25 +0200

pd-faust (0.4-1) natty; urgency=low

  * Initial release

 -- Albert Graef <Dr.Graef@t-online.de>  Thu, 24 May 2012 23:52:49 +0200

=== debian/control ===
Source: pd-faust
Section: devel
Priority: extra
Maintainer: Albert Graef <aggraef@gmail.com>
Build-Depends: debhelper (>= 7.0.50~), pure, pure-dev, pd-pure, pure-faust, pure-midi, pure-stldict, pkg-config, puredata, faust (>= 0.9.47) | faust2
Standards-Version: 3.9.5
Homepage: http://purelang.bitbucket.org

Package: pd-faust
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libpure8, pd-pure, pure-faust, pure-midi, pure-stldict
Suggests: faust (>> 0.9.46) | faust2
Description: Run Faust signal processors in Pd
 This package provides a dynamic environment for running Faust dsps in Pd,
 written in Pure. The basic functionality is somewhat similar to what the
 faust2pd script provides, but Faust units can be reloaded at any time, in
 which case their Pd GUIs are regenerated dynamically, inside Pd. It also
 supports MIDI and OSC controller mapping and controller automation. The
 package thus turns Pd into an interactive development environment for Faust,
 Grame's functional signal processing language.
 .
 Note: After installing the package, you still need to enable pd-faust in Pd.
 To these ends, add /usr/lib/pd/extra/faust to your Pd search path (under
 Preferences/Path in Pd) and add 'pdfaust' to your preloaded library modules
 (Preferences/Startup).
